import es, socket, re, xdrlib, string, threading, os, playerlib

number = 0
servers = {}
connection = None
csc_version = es.ServerVar("csc_version", "0.1", "The version of CSC you are running.")
csc_version.makepublic()

filepath = es.getAddonPath('csc') + "/servers/"
for file in os.listdir(filepath):
    global servers
    filename = file.replace(".txt", "")
    filename = {}
    path = filepath + file
    file = open(path, "r")
    number += 1
    servers[number] = {}
    for line in file:
        if "IP:" in line:
            ip = line.replace("IP: ", "", 1)
            ip = ip.rstrip()
            servers[number]["IP"] = ip
        if "Port:" in line:
            port = line.replace("Port: ", "", 1)
            port = port.rstrip()
            servers[number]["PORT"] = port
        if "RCON Password:" in line:
            rcon = line.replace("RCON Password: ", "", 1)
            rcon = rcon.rstrip()
            servers[number]["RCON"] = rcon

SERVERDATA_RESPONSE_VALUE = 0
SERVERDATA_AUTH_RESPONSE = 2
SERVERDATA_EXECCOMMAND = 2
SERVERDATA_AUTH = 3
RCON_EMPTY_RESP = (10,0,0,'','')

class SRCDS_Error(Exception):
    pass

class RCON_Error(Exception):
    pass

class DoConnection(threading.Thread):
    def __init__(self, userid, text, host, port, rconpass, timeout=2.0):
        self.userid, self.text, self.ip, self.port, self.rconpass, self.timeout = userid, text, socket.gethostbyname(host), int(port), rconpass, int(timeout)
        self.udpsock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        self.tcpsock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.udpsock.settimeout(self.timeout)
        self.tcpsock.settimeout(self.timeout)
        self.udpsock.connect((self.ip, self.port))
        self.challenge, self.rcon_challenege, self.req_id, self.hl = -1, 0, 0, 0
        if self.rconpass: 
            self._authenticate_rcon()
        player = playerlib.getPlayer(userid)
        username = player.attributes['name']
        dead = player.attributes['isdead']
        team = player.attributes['teamid']
        if team != 0:
            if team == 1:
                team = "SPEC"
            if team == 2:
                team = "T"
            if team == 3:
                team = "CT"
        else:
            team = "?"
        if dead == 0:
            self._any_rcon_response("es_msg #multi #default[" + team + "]#lightgreen" + username + "#default : " + text)
        else:
            if team != "SPEC":
                self._any_rcon_response("es_msg #multi #default[*DEAD*][" + team + "]#lightgreen" + username + "#default : " + text)
            else:
                self._any_rcon_response("es_msg #multi #default[" + team + "]#lightgreen" + username + "#default : " + text)
        self.disconnect()
        threading.Thread.__init__(self)

    def send_packet(self, command, string1, string2=''):
        self.req_id += 1
        packet = string1 + '\x00' + string2 + '\x00'
        packet = sourceint2(command) + packet
        packet = sourceint2(self.req_id) + packet
        packet = sourceint2(len(packet)) + packet
        self.tcpsock.send(packet)
        return self.req_id
        
    def read_packet(self):
        raw_packetlen = self.tcpsock.recv(4)
        packetlen = sourceint(raw_packetlen)
        raw_packet = self.tcpsock.recv(packetlen)
        req_id = sourceint(raw_packet[0:4])
        command = sourceint(raw_packet[4:8])
        raw_packet = str(raw_packet[8:])
        if len(raw_packet) == 2:
            strs = ['', '']
        else:
            strs = re.split('[\000]', raw_packet[:-1], 1)
        return (packetlen, req_id, command, strs[0], strs[1])    

    def _authenticate_rcon(self):
        self.tcpsock.connect((self.ip, self.port))
        req_id = self.send_packet(SERVERDATA_AUTH, self.rconpass, '')
        i = 0
        result = RCON_EMPTY_RESP
        while result != (10,req_id,SERVERDATA_AUTH_RESPONSE,'',''):
            result = self.read_packet()
            if result[1] == -1:
                raise RCON_Error, 'Invalid RCON password.'

    def _any_rcon_response(self, command):
        req_id = self.send_packet(SERVERDATA_EXECCOMMAND, command)
        result = RCON_EMPTY_RESP
        while result[1] != req_id:
            result = self.read_packet()
        return result

    def disconnect(self):
        self.udpsock.close()

def sourceint(data):
    s = ""
    for c in data:
        s = c + s
    p = xdrlib.Unpacker(s)
    return p.unpack_int()

def sourceint2(integer):
    s = ""
    p = xdrlib.Packer()
    p.pack_int(integer)
    data = p.get_buffer()
    for c in data:
        s = c + s
    return s

def sourcefloat(data):
    s = ""
    for c in data:
        s = c + s
    p = xdrlib.Unpacker(s)
    return p.unpack_float()

def read_byte(data):
    return (ord(data[0]), data[1:])

def read_char(data):
    return (str(data[0]), data[1:])

def read_string(data):
    s = ''
    i = 0
    while 1:
        if str(data[i]) != '\x00':
            s = s + str(data[i])
            i += 1
        else:
            break
    return (s, data[i+1:])

def read_int(data):
    ret = sourceint(data[0:4])
    return (ret, data[4:])

def read_float(data):
    ret = sourcefloat(data[0:4])
    return (ret, data[4:])

def player_say(event_var):
    for number in servers:
        number = int(number)
        DoConnection(event_var["userid"], event_var["text"], servers[number]["IP"], servers[number]["PORT"], servers[number]["RCON"]).start();

def round_start(event_var):
    es.msg("#multi", "#green[CSC] #lightgreenCrossServerChat #defaultis enabled, chat messages will be shared over multiple servers.")